"
 COPYRIGHT (c) 2006 by eXept Software AG
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:libtool' }"

"{ NameSpace: Tools }"

SimpleView subclass:#CodeView2
	instanceVariableNames:'gutterView textView textViewScroller methodHolder languageHolder
		classHolder browserHolder codeAspect modifiedChannel
		showGutterChannel modeHolder services syntaxElements
		syntaxElementSelection highlightEmphasis diffMode
		synchronizedCodeViews'
	classVariableNames:'TraceSelectors'
	poolDictionaries:''
	category:'Interface-CodeView'
!

SimpleView subclass:#GutterView
	instanceVariableNames:'codeView textView textViewScroller widthAnnotations widthDiffInfo'
	classVariableNames:''
	poolDictionaries:''
	privateIn:CodeView2
!

CodeView subclass:#TextView
	instanceVariableNames:'codeView gutterView diffMode deletedLines insertedLines
		lastFirstLine changedLines scrolled originDiffText emptyLines
		changedDiffText'
	classVariableNames:''
	poolDictionaries:''
	privateIn:CodeView2
!

!CodeView2 class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2006 by eXept Software AG
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!CodeView2 class methodsFor:'initialization'!

initialize
    "Invoked at system start or when the class is dynamically loaded."

    "/ please change as required (and remove this comment)

    TraceSelectors := IdentitySet new.

    "Modified: / 14-02-2010 / 15:36:11 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CodeView2 class methodsFor:'debugging'!

trace: aSelector

    TraceSelectors add: aSelector

    "Created: / 14-02-2010 / 09:26:30 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

untrace: aSelector

    TraceSelectors remove: aSelector ifAbsent:[]

    "Created: / 14-02-2010 / 09:50:31 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

untraceAll

    TraceSelectors := IdentitySet new

    "Created: / 14-02-2010 / 09:53:32 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CodeView2 class methodsFor:'examples'!

example1

    | window codeView |


    window := StandardSystemView new.
    window extent: 300 @ 300.              
    window label: 'CodeView2 example1'.

    codeView := Tools::CodeView2 in: window.
    codeView
        origin: 0.1 @ 0.1
        corner: 0.9 @ 0.9.


    window open.

    "Created: / 02-09-2009 / 21:48:56 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CodeView2 class methodsFor:'menu specs'!

editMenu
    "This resource specification was automatically generated
     by the MenuEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the MenuEditor may not be able to read the specification."

    "
     MenuEditor new openOnClass:Tools::CodeView2 andSelector:#editMenu
     (Menu new fromLiteralArrayEncoding:(Tools::CodeView2 editMenu)) startUp
    "

    <resource: #menu>

    ^ 
     #(Menu
        (
         (MenuItem
            label: 'Implementors'
            itemValue: browseImplementorsOfIt
            translateLabel: true
            shortcutKey: ImplementorsOfIt
          )
         (MenuItem
            label: 'Senders'
            itemValue: browseSendersOfIt
            translateLabel: true
            shortcutKey: SendersOfIt
          )
         (MenuItem
            label: 'Refactor'
            translateLabel: true
            isVisible: false
            shortcutKey: Shift
          )
         (MenuItem
            label: '-'
          )
         (MenuItem
            label: 'Accept'
            itemValue: accept
            translateLabel: true
            shortcutKey: Accept
          )
         (MenuItem
            label: '-'
          )
         (MenuItem
            label: 'Cut'
            itemValue: cut
            translateLabel: true
            shortcutKey: Cut
          )
         (MenuItem
            label: 'Copy'
            itemValue: copySelection
            translateLabel: true
            shortcutKey: Copy
          )
         (MenuItem
            label: 'Paste'
            itemValue: pasteOrReplace
            translateLabel: true
            shortcutKey: Paste
          )
         (MenuItem
            label: '-'
          )
         (MenuItem
            label: 'Undo'
            itemValue: undo
            translateLabel: true
            shortcutKey: Undo
          )
         (MenuItem
            label: '-'
          )
         (MenuItem
            label: 'Do it'
            itemValue: doIt
            translateLabel: true
            shortcutKey: DoIt
          )
         (MenuItem
            label: 'Print it'
            itemValue: printIt
            translateLabel: true
            shortcutKey: PrintIt
          )
         (MenuItem
            label: 'Inspect it'
            itemValue: inspectIt
            translateLabel: true
            shortcutKey: InspectIt
          )
         (MenuItem
            label: 'Profile it'
            itemValue: profileIt
            translateLabel: true
            shortcutKey: InspectIt
          )
         (MenuItem
            label: '-'
          )
         (MenuItem
            label: 'Show Gutter'
            nameKey: ShowGutter
            translateLabel: true
            indication: showGutterChannel
          )
         (MenuItem
            label: 'More'
            nameKey: More
            translateLabel: true
          )
         (MenuItem
            label: 'Services'
            translateLabel: true
            submenuChannel: servicesMenu
          )
         (MenuItem
            label: 'Debug'
            translateLabel: true
            submenu: 
           (Menu
              (
               (MenuItem
                  label: 'Inspect '
                  itemValue: inspectView
                  translateLabel: true
                )
               (MenuItem
                  label: 'Inspect Syntax Elements'
                  itemValue: inspectSyntaxElements
                  translateLabel: true
                )
               (MenuItem
                  label: 'Inspect selected selector'
                  itemValue: inspectSelectedSelector
                  translateLabel: true
                )
               )
              nil
              nil
            )
          )
         )
        nil
        nil
      )
! !

!CodeView2 methodsFor:'accessing'!

acceptAction:aBlock

    textView acceptAction: aBlock

    "Modified: / 01-08-2010 / 20:40:17 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

codeAspect

    |app|
    codeAspect ifNotNil:[^codeAspect].

    ^((app := self topView application) notNil and:[app respondsTo: #codeAspect])
        ifTrue:[app codeAspect]
        ifFalse:[#expression]

    "Modified: / 14-02-2010 / 19:51:44 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

codeAspect:aSymbol
    codeAspect := aSymbol.
!

contents

    ^textView contents

    "Created: / 14-02-2010 / 22:13:47 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

contents: aStringOrStringCollection

    textView contents: aStringOrStringCollection.
    "/self update:#value with: aStringOrStringCollection from: textView model

    "Modified: / 07-03-2010 / 20:10:43 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

diffMode
    ^ diffMode
!

diffMode:aBoolean
    diffMode := aBoolean.
    textView diffMode: aBoolean

    "Modified: / 08-04-2011 / 20:50:51 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

font

    ^textView font

    "Created: / 16-02-2010 / 10:26:31 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

font: aFont

    ^textView font: aFont

    "Created: / 16-02-2010 / 10:26:26 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

language
    "return the value in 'languageHolder'"

    | v |

    (v := self languageHolder value) notNil ifTrue:[^v].
    (v := self methodHolder value) notNil ifTrue:[^v programmingLanguage].
    (v := self classHolder value) notNil ifTrue:[^v programmingLanguage].

    ^SmalltalkLanguage instance

    "Modified: / 17-06-2011 / 12:36:44 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

language: newValue
    "set the value in 'languageHolder'"

    self languageHolder value: newValue
!

mode

    ^self modeHolder value

    "Created: / 13-06-2011 / 10:49:52 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

mode: aSymbol

    self assert: (#(expression method) includes: aSymbol).    
    
    ^self modeHolder value: aSymbol

    "Created: / 13-06-2011 / 10:50:28 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 15-06-2011 / 16:37:45 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

modified
    "return true if text was modified"

    ^ modifiedChannel value
!

modified:aBoolean
    "set/clear the modified flag"

    modifiedChannel value:aBoolean

    "Modified: 14.2.1997 / 16:44:05 / cg"
!

scrolledView

    ^self

    "Created: / 14-02-2010 / 22:54:56 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

showGutter

    ^showGutterChannel value

    "Created: / 23-06-2010 / 19:37:47 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

synchronizeWith: aCodeView

    self assert: aCodeView ~= self.
    (synchronizedCodeViews includes: aCodeView) ifTrue:[^self].    
    synchronizedCodeViews := synchronizedCodeViews copyWith: aCodeView.

    "Created: / 06-04-2010 / 14:13:14 / Jakub <zelenja7@fel.cvut.cz>"
    "Modified: / 23-06-2010 / 17:01:47 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CodeView2 methodsFor:'aspects'!

browserHolder
    browserHolder ifNil:[
        browserHolder := ValueHolder new
    ].
    ^browserHolder

    "Modified: / 14-02-2010 / 19:27:33 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

browserHolder:aValueModel
    browserHolder := aValueModel.
!

classHolder
    "return/create the 'classHolder' value holder (automatically generated)"

    classHolder isNil ifTrue:[
        classHolder := ValueHolder with: UndefinedObject.
        classHolder addDependent:self.
    ].
    ^ classHolder

    "Modified: / 16-02-2010 / 10:53:52 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

classHolder:aValueModel
    "set the 'classHolder' value holder (automatically generated)"

    |old oldValue newValue|

    classHolder notNil ifTrue:[
        oldValue := classHolder value.
        classHolder removeDependent:self.
    ].
    classHolder := aValueModel.
    classHolder notNil ifTrue:[
        classHolder addDependent:self.
    ].
    old := methodHolder.
    newValue := classHolder value.
    oldValue ~~ newValue ifTrue:[
        self update:#value with:newValue from:classHolder.
    ].

    self changed: #classHolder with: old -> classHolder

    "Modified: / 17-06-2011 / 12:56:10 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

languageHolder
    "return/create the 'languageHolder' value holder (automatically generated)"

    languageHolder isNil ifTrue:[
        languageHolder := ValueHolder with: SmalltalkLanguage instance.
        languageHolder addDependent:self.
    ].
    ^ languageHolder
!

languageHolder:aValueModel
    "set the 'languageHolder' value holder (automatically generated)"

    |old oldValue newValue|

    languageHolder notNil ifTrue:[
        oldValue := languageHolder value.
        languageHolder removeDependent:self.
    ].
    languageHolder := aValueModel.
    languageHolder notNil ifTrue:[
        languageHolder addDependent:self.
    ].
    old := languageHolder.
    newValue := languageHolder value.
    oldValue ~~ newValue ifTrue:[
        self update:#value with:newValue from:languageHolder.
    ].

    self changed: #languageHolder with: old -> languageHolder

    "Modified: / 17-06-2011 / 12:56:30 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

methodHolder
    "return/create the 'methodHolder' value holder (automatically generated)"

    methodHolder isNil ifTrue:[
        methodHolder := ValueHolder new.
        methodHolder addDependent:self.
    ].
    ^ methodHolder
!

methodHolder:aValueModel
    "set the 'methodHolder' value holder (automatically generated)"

    |old oldValue newValue|

    methodHolder notNil ifTrue:[
        oldValue := methodHolder value.
        methodHolder removeDependent:self.
    ].
    old := methodHolder.
    methodHolder := aValueModel.
    methodHolder notNil ifTrue:[
        methodHolder addDependent:self.
    ].
    newValue := methodHolder value.
    oldValue ~~ newValue ifTrue:[
        self update:#value with:newValue from:methodHolder.
    ].

    self changed: #methodHolder with: old -> methodHolder

    "Modified: / 17-06-2011 / 12:55:47 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

modeHolder
    "return/create the 'modeHolder' value holder (automatically generated)"

    modeHolder isNil ifTrue:[
        modeHolder := #expression asValue.
        modeHolder addDependent:self.
    ].
    ^ modeHolder

    "Modified: / 13-06-2011 / 10:52:11 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

modeHolder:something
    "set the 'modeHolder' value holder (automatically generated)"

    |oldValue newValue|

    modeHolder notNil ifTrue:[
        oldValue := modeHolder value.
        modeHolder removeDependent:self.
    ].
    modeHolder := something.
    modeHolder notNil ifTrue:[
        modeHolder addDependent:self.
    ].
    newValue := modeHolder value.
    oldValue ~~ newValue ifTrue:[
        self update:#value with:newValue from:modeHolder.
    ].

    self changed: #modeHolder with: modeHolder

    "Modified: / 17-06-2011 / 12:55:01 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

model: aValueModel

    |oldValue newValue|

    textView model notNil ifTrue:[
        oldValue := textView model value.
        textView model removeDependent:self.
    ].
    textView model: aValueModel.
    textView model notNil ifTrue:[
        textView model addDependent:self.
    ].
    newValue := textView model value.
    oldValue ~~ newValue ifTrue:[
        self update:#value with:newValue from:textView model.
    ].

    "Modified: / 17-06-2011 / 12:54:32 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CodeView2 methodsFor:'change & update'!

update:aspect with:param from:sender

    sender == showGutterChannel ifTrue:
        [^self updateGutterVisibility].

    services do:
        [ :each | 
        each isEnabled ifTrue:
            [each update:aspect with:param from:sender ]].

    super update:aspect with:param from:sender

    "Modified: / 23-06-2010 / 19:05:39 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

updateGutterVisibility

    self showGutterChannel value ifTrue:[        
        textViewScroller origin:(gutterView width @ 0.0) corner:(1.0 @ 1.0).
        gutterView beVisible.
    ] ifFalse:[
        textViewScroller origin:(0.0 @ 0.0) corner:(1.0 @ 1.0).
        gutterView beInvisible.
    ]

    "Created: / 23-06-2010 / 19:05:39 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CodeView2 methodsFor:'channels'!

modifiedChannel
    "return the valueHolder holding true if text was modified"

    ^ modifiedChannel
!

modifiedChannel:aValueHolder
    "set the valueHolder holding true if text was modified"

    |prev|

    prev := modifiedChannel.
    modifiedChannel := aValueHolder.
    self setupChannel:aValueHolder for:nil withOld:prev

    "Created: / 30.1.1998 / 14:51:32 / cg"
!

showGutterChannel

    ^showGutterChannel

    "Created: / 23-06-2010 / 19:02:15 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

showGutterChannel:aValueHolder
    "set the valueHolder holding true if text was modified"

    |prev|

    prev := showGutterChannel.
    showGutterChannel := aValueHolder.
    self setupChannel:aValueHolder for:nil withOld:prev

    "Created: / 23-06-2010 / 19:03:26 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CodeView2 methodsFor:'delegation'!

doesNotUnderstand: aMessage

    ((textView respondsTo: aMessage selector) 
    and:[(TraceSelectors includes:aMessage selector) not])
        ifTrue:[^aMessage sendTo: textView].
    ^super doesNotUnderstand: aMessage

    "Created: / 13-02-2010 / 23:27:09 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 14-02-2010 / 09:53:06 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

hasSelection

    ^textView hasSelection

    "Created: / 14-02-2010 / 09:53:54 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CodeView2 methodsFor:'delegation - drawing'!

drawLine:lineNo in: view atX:x y:y width: w height:h from:startCol to:endColOrNil with:fg and:bg
    "See the comment in
     CodeViewService>>drawLine:in:atX..."

    services do:[:each|
        each drawLine:lineNo in: view atX:x y:y width: w height:h from:startCol to:endColOrNil with:fg and:bg
    ]

    "Created: / 17-06-2011 / 13:50:20 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

redrawVisibleLine: visLineNr

    "Created: / 07-03-2010 / 14:44:23 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

redrawVisibleLine:visLine col:colNr

    "Modified: / 05-11-2007 / 17:35:53 / cg"
    "Modified: / 07-03-2010 / 14:45:32 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

redrawVisibleLine:visLine from:startCol

    "Modified: / 07-03-2010 / 14:46:18 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

redrawVisibleLine:visLine from:startCol to:endCol

    "Modified: / 07-03-2010 / 14:46:22 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CodeView2 methodsFor:'delegation - events'!

buttonMotion: button x:x y:y in: view

    "Delegates events to services. Answers true iff at least
     one service handler method returns true. In that case,
     the event is is NOT processes by the view."

    ^services
        inject: false
        into:
            [:processed :service|
            service isEnabled 
                ifFalse:
                    [processed]
                ifTrue:
                    [processed | ((service buttonMotion: button x:x y:y in: view) == true)]].

    "Modified: / 07-03-2010 / 13:53:18 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

buttonPress: button x:x y:y in: view

    "Delegates events to services. Answers true iff at least
     one service handler method returns true. In that case,
     the event is is NOT processes by the view."

    ^services
        inject: false
        into:
            [:processed :service|
            service isEnabled 
                ifFalse:
                    [processed]
                ifTrue:
                    [processed | ((service buttonPress: button x:x y:y in: view) == true)]].

    "Modified: / 07-03-2010 / 13:53:47 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

keyPress: key x:x y:y in: view

    "Delegates events to services. Answers true iff at least
     one service handler method returns true. In that case,
     the event is is NOT processes by the view."

    ^services
        inject: false
        into:
            [:processed :service|
            service isEnabled 
                ifFalse:
                    [processed]
                ifTrue:
                    [processed | ((service keyPress: key x:x y:y in: view) == true)]].

    "Modified: / 07-03-2010 / 13:54:15 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

keyRelease: key x:x y:y in: view

    "Delegates events to services. Answers true iff at least
     one service handler method returns true. In that case,
     the event is is NOT processes by the view."

    ^services
        inject: false
        into:
            [:processed :service|
            service isEnabled 
                ifFalse:
                    [processed]
                ifTrue:
                    [processed | ((service keyRelease: key x:x y:y in: view) == true)]].

    "Modified: / 07-03-2010 / 13:54:27 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

scrollDown: nLines in: view

    view == textView 
        ifTrue:
            ["/my text view scrolled...
            synchronizedCodeViews do:[:codeView|codeView scrollDown: nLines in: view]]
        ifFalse:
            ["/other code view scrolls and I'm notified about that
            textView basicScrollDown: nLines]

    "Created: / 06-04-2010 / 14:02:39 / Jakub <zelenja7@fel.cvut.cz>"
!

scrollUp: nLines in: view

    view == textView 
        ifTrue:
            ["/my text view scrolled...
            synchronizedCodeViews do:[:codeView|codeView scrollUp: nLines in: view]]
        ifFalse:
            ["/other code view scrolls and I'm notified about that
            textView basicScrollUp: nLines]

    "Created: / 06-04-2010 / 14:02:39 / Jakub <zelenja7@fel.cvut.cz>"
! !

!CodeView2 methodsFor:'diff mode'!

recomputeDiff:view 
    |t1 t2 pom diffHelper view2|

    t1 := view getNewOriginText.
    synchronizedCodeViews do:[:codeView | 
        view2 := codeView
    ].
    view changedDiffText:false.
    view2 changedDiffText:false.
    t2 := view2 getNewOriginText.
    pom := DiffCodeView2 new.
    (view == textView) ifTrue:[
        diffHelper := pom computeDiffDataForText1:t1 text2:t2.
        (view) contents:(diffHelper text1).
        (view) deletedLines:(diffHelper deleted).
        (view) changedLines:(diffHelper changed).
        (view) originDiffText:t1.
        (view) emptyLines:(diffHelper inserted).
        (view) changedLines:(diffHelper changed).
        (view2) contents:(diffHelper text2).
        (view2) insertedLines:(diffHelper inserted).
        (view2) changedLines:(diffHelper changed).
        (view2) originDiffText:t2.
        (view2) emptyLines:(diffHelper deleted).
    ].

    "Modified: / 22-06-2010 / 23:35:41 / Jakub <zelenja7@fel.cvut.cz>"
    "Modified: / 23-06-2010 / 17:25:59 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CodeView2 methodsFor:'initialization'!

initialize
    "Invoked when a new instance is created."
    "Call super initialize"
    
    super initialize.
     "Now set up some visual properties"
    self level:-1.
     "Now initialize sub-views"
    showGutterChannel := (ValueHolder with: true).
    showGutterChannel addDependent: self.     
    self initializeGutterView.
    self initializeTextView.
    gutterView setCodeView:self.
    textView setCodeView:self.
    modifiedChannel := ValueHolder with:false.    
    diffMode := false.
    synchronizedCodeViews := #().
     "Initialize services"
    services := OrderedCollection new.
    self initializeServices.

    "Modified: / 14-12-2009 / 13:59:53 / Jindra <a>"
    "Modified: / 06-04-2010 / 13:56:35 / Jakub <zelenja7@fel.cvut.cz>"
    "Modified: / 23-06-2010 / 19:30:24 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

initializeGutterView

    gutterView := CodeView2::GutterView new.
    gutterView origin:(0.0 @ 0.0) corner:(gutterView preferredWidth @ 1.0).
    showGutterChannel value ifTrue:[self addSubView: gutterView].

    "Created: / 02-09-2009 / 21:35:56 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 23-06-2010 / 19:14:55 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

initializeServices

    | serviceClasses |
    serviceClasses := CodeViewService availableServices.
    serviceClasses do:
        [:cls|
        self registerService: cls new].

    "Modified: / 07-03-2010 / 13:50:50 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

initializeTextView

    "Initialize textView. gutterView have to be 
     already initialized!!"

    textViewScroller := HVScrollableView for: CodeView2::TextView in: self.
    textViewScroller
        origin: ((self showGutter ifTrue:[gutterView width] ifFalse:[0.0]) @ 0.0)
        corner: 1.0@1.0;
        level: 0.
    textView := textViewScroller scrolledView.
    textView level: 0.

    textView modifiedChannel addDependent: self.

    "Created: / 02-09-2009 / 21:36:02 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 23-06-2010 / 19:38:20 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CodeView2 methodsFor:'menu actions'!

browseImplementorsOfIt
    "automatically generated by UIEditor ..."

    "*** the code below performs no action"
    "*** (except for some feedback on the Transcript)"
    "*** Please change as required and accept in the browser."
    "*** (and replace this comment by something more useful ;-)"

    "action to be added ..."

    Transcript showCR:self class name, ': action for #browseImplementorsOfIt ...'.
!

browseSendersOfIt
    "automatically generated by UIEditor ..."

    "*** the code below performs no action"
    "*** (except for some feedback on the Transcript)"
    "*** Please change as required and accept in the browser."
    "*** (and replace this comment by something more useful ;-)"

    "action to be added ..."

    Transcript showCR:self class name, ': action for #browseSendersOfIt ...'.
!

copySelection

    textView copySelection

    "Created: / 16-02-2010 / 19:36:37 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

cut

    textView cut

    "Created: / 16-02-2010 / 19:36:06 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

doIt

    textView doIt

    "Modified: / 16-02-2010 / 19:38:15 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

inspectIt

    textView inspectIt

    "Modified: / 16-02-2010 / 19:38:26 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

inspectSelectedSelector

    self error: 'Not yet implemented'

    "Modified: / 14-02-2010 / 15:58:15 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

inspectSyntaxElements

    syntaxElements inspect

    "Modified: / 14-02-2010 / 15:57:58 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

inspectView

    self inspect

    "Modified: / 25-03-2010 / 17:58:10 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

pasteOrReplace

    textView pasteOrReplace

    "Created: / 16-02-2010 / 19:37:08 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

printIt

    textView printIt

    "Modified: / 16-02-2010 / 19:38:05 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

profileIt

    textView profileIt

    "Created: / 27-08-2010 / 22:12:42 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

undo

    textView undo

    "Created: / 16-02-2010 / 19:35:50 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CodeView2 methodsFor:'menus-dynamic'!

editMenu

    | editMenu superEditMenu moreMenu moreMenuItem showGutterItem |
    editMenu := self class editMenu decodeAsLiteralArray.
    superEditMenu := textView superEditMenu.
    moreMenu := superEditMenu subMenuAt: superEditMenu numberOfItems.
    moreMenuItem := editMenu menuItemLabeled: 'More'.
    showGutterItem := editMenu atNameKey: #ShowGutter.
    showGutterItem indication: showGutterChannel.
    moreMenuItem submenu: moreMenu asMenu.
    editMenu findGuiResourcesIn: self.
    ^editMenu

    "Created: / 25-12-2007 / 10:10:01 / janfrog"
    "Modified: / 25-12-2007 / 19:50:53 / janfrog"
    "Modified: / 18-10-2008 / 20:31:16 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 23-06-2010 / 19:13:22 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

implementorsMenu: implementors selector: selector  
    | menu|

    menu := Menu new.
    implementors isNilOrEmptyCollection ifTrue:[
        menu addItem:(MenuItem label:'No implementors found') disable
    ] ifFalse:[
        menu addItem:(MenuItem 
                    label:(selector storeString , (' (all implementors) ') asText allItalic)
                    value:[
                        self browseMethods:implementors
                            label:'Implementors of ' , selector storeString
                    ]).
        menu addSeparator.
        implementors do:[:mth | 
            menu 
                addItem:(MenuItem label:(selector storeString 
                                , (' in ' , mth containingClass name asText allBold))
                        value:[ self browseMethod:mth label: 'Implementor of ' , selector storeString  ])
        ]
    ].
    ^ menu

    "Modified: / 19-10-2008 / 08:16:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Created: / 14-02-2010 / 19:39:37 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

sendersMenu: senders  selector: selector  
    | menu|

    menu := Menu new
    senders isNilOrEmptyCollection ifTrue:[
        menu addItem:(MenuItem label:'No senders found') disable
    ] ifFalse:[
        menu addItem:(MenuItem 
                    label:(selector storeString , (' (all senders)') asText allItalic)
                    value:[
                        self browseMethods:senders
                            label:'Senders of ' , selector storeString
                    ]).
        menu addSeparator.
        senders do:[:mth | 
            menu 
                addItem:(MenuItem label:(mth selector storeString 
                                , (' in ' , mth containingClass name asText allBold))
                        value:[ self browseMethod:mth label: 'Sender of ' , selector storeString ])
        ]
    ].
    ^ menu

    "Modified: / 19-10-2008 / 08:17:00 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Created: / 14-02-2010 / 19:40:10 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

servicesMenu

    | menu |
    menu := Menu new.
    services do:
        [ :service | | item |
        item := MenuItem label: service label.
        item indication:
            ((AspectAdaptor forAspect: #enabled) subject: service).
        menu addItem: item].
    ^menu

    "Created: / 07-03-2010 / 14:03:00 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CodeView2 methodsFor:'private'!

codeCompletion
    |cls 
"/     crsrPos interval node checkedNode
"/     char start stop selectorSoFar matchingSelectors
    |


    cls := self classHolder value.
    cls isNil ifTrue:[
        self showInfo:'No class'.
        ^ self.
    ].
    UserInformation handle:[:ex |
        self showInfo:(ex messageText).
        ex proceed.
    ] do:[
        self withWaitCursorDo:[
            DoWhatIMeanSupport codeCompletionForClass:cls codeView:self.
        ]
    ].
    ^ self.

"/
"/    interval := self selectedInterval.
"/    interval isEmpty ifTrue:[
"/        crsrPos := codeView characterPositionOfCursor - 1.
"/        char := codeView characterUnderCursor.
"/        [crsrPos > 1 and:[char isSeparator or:['.' includes:char]]] whileTrue:[
"/            crsrPos := crsrPos - 1.
"/            char := codeView characterAtCharacterPosition:crsrPos.
"/        ].
"/        interval := crsrPos to:crsrPos.
"/    ].
"/
"/    node := self findNodeForInterval:interval allowErrors:true.
"/    [node isNil] whileTrue:[
"/        "/ expand to the left ...
"/        interval start > 1 ifFalse:[
"/            self showInfo:'No parseNode found'.
"/            ^ self.
"/        ].
"/        interval start:(interval start - 1).
"/        node := self findNodeForInterval:interval allowErrors:true.
"/    ].
"/
"/    node isVariable ifTrue:[
"/        self codeCompletionForVariable:node inClass:cls.
"/        ^ self.
"/    ].
"/
"/    checkedNode := node.
"/    [checkedNode notNil] whileTrue:[
"/        checkedNode isMessage ifTrue:[
"/            self codeCompletionForMessage:checkedNode inClass:cls.
"/            ^ self
"/        ].
"/        checkedNode isMethod ifTrue:[
"/            self codeCompletionForMethod:checkedNode inClass:cls.
"/            ^ self.
"/        ].
"/        checkedNode := checkedNode parent.
"/    ].
"/
"/    self showInfo:'Node is neither variable nor message.'.

    "Modified: / 04-07-2006 / 18:48:26 / fm"
    "Modified: / 20-11-2006 / 12:30:59 / cg"
    "Modified: / 16-02-2010 / 10:53:07 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

reallyModified
    "check for modified code by comparing the source against
     the codeViews contents.
     Thats the true modified value (in case user undid its changes,
     and the displayed text is actually original"

    |modified changedSource originalSource s1 s2|

    textView modified ifTrue:[^true].

    "/ higher prio to prevent it from being changed while we convert it (by editing)
    Processor activeProcess
        withHigherPriorityDo:[
            changedSource :=  textView contentsAsString asStringCollection.
        ].
    changedSource := changedSource collect:[:line | line string withoutTrailingSeparators withTabsExpanded].
    changedSource := changedSource collect:[:line | line isEmpty ifTrue:[nil] ifFalse:[line]].
    [changedSource size > 0 and:[changedSource last isNil]] whileTrue:[
        changedSource := changedSource copyWithoutLast:1
    ].
    changedSource := changedSource asString.

        originalSource := textView model value ? ''.

        originalSource := originalSource asStringCollection.
        originalSource := originalSource collect:[:line | line string withoutTrailingSeparators withTabsExpanded].
        originalSource := originalSource collect:[:line | line isEmpty ifTrue:[nil] ifFalse:[line]].
        [originalSource size > 0 and:[originalSource last isNil]] whileTrue:[
            originalSource := originalSource copyWithoutLast:1
        ].

        s1 := originalSource asString.
        s2 := changedSource asString.
        modified := (s1 ~= s2).

    ^ modified

    "Created: / 06-02-2010 / 19:59:37 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

showInfo: message

    | app |
    (app := self topView application) ifNotNil:
        [(app respondsTo: #showInfo:) ifTrue:
            [app showInfo: message]].

    "Modified: / 13-02-2010 / 23:25:53 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CodeView2 methodsFor:'private-accessing'!

gutterView

    ^gutterView

    "Created: / 14-02-2010 / 15:21:27 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

syntaxElementSelection
    ^ syntaxElementSelection
!

syntaxElementSelection:something
    syntaxElementSelection := something.
!

syntaxElements
    ^ syntaxElements
!

syntaxElements:something
    syntaxElements := something.
!

textView

    ^textView

    "Created: / 14-02-2010 / 15:21:12 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

textViewScroller

    ^textViewScroller

    "Created: / 14-02-2010 / 15:21:18 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CodeView2 methodsFor:'queries'!

isCodeView2

    ^true

    "Created: / 20-07-2010 / 15:43:05 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CodeView2 methodsFor:'services'!

registerService: aCodeViewService

    services add: aCodeViewService.
    aCodeViewService registerIn: self

    "Created: / 06-03-2010 / 19:19:40 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

underService: aCodeViewService

    services remove: aCodeViewService ifAbsent:[^self].
    aCodeViewService unregister.

    "Created: / 06-03-2010 / 19:21:10 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CodeView2 methodsFor:'testing'!

isTextView

    ^true

    "Created: / 14-02-2010 / 22:13:37 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CodeView2::GutterView methodsFor:'accessing'!

setTextView: aTextView

    self assert: textView isNil message:'Attempting to set textView twice'.
    textView := aTextView.

    self backgroundPaint: textView backgroundPaint darkened lighter.
    self paint: textView paint.
    self font: textView font.

    "Created: / 02-09-2009 / 21:55:43 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 14-12-2009 / 15:09:29 / Jindra <a>"
    "Modified: / 09-02-2010 / 20:03:06 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

setTextViewScroller:aScr
    textViewScroller := aScr.

    "Created: / 07-12-2009 / 22:36:31 / Jindra <a>"
! !

!CodeView2::GutterView methodsFor:'accessing-dimensions'!

padding

    ^self paddingLeft + self paddingRight 
        + (widthAnnotations ? 0) 
        + (widthDiffInfo ? 0)

    "Created: / 14-02-2010 / 22:28:57 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 16-06-2011 / 14:01:08 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

paddingLeft

    ^0"px"

    "Created: / 14-02-2010 / 22:27:17 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 16-06-2011 / 13:47:53 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

paddingRight

    ^0"px"

    "Created: / 14-02-2010 / 22:27:22 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 16-06-2011 / 13:47:30 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

preferredExtent

    | w h |

    explicitExtent ifNotNil:[^explicitExtent].
    preferredExtent ifNotNil:[^preferredExtent].

    w := (self font widthOf:'00') + self padding.
    h := textView ifNotNil:[textView height] ifNil:[self font height * 12].

    ^preferredExtent := w @ h

    "Modified: / 16-06-2011 / 14:03:11 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CodeView2::GutterView methodsFor:'change & update'!

update:something with:aParameter from:changedObject
    "Invoked when an object that I depend upon sends a change notification."

    self shown ifFalse:[^self].

    (changedObject == textView and: [something == #sizeOfContents])
        ifTrue:[^self invalidate].

    "/ changedObject == someOfMyValueHolders ifTrue:[
    "/     self doSomethingApropriate.
    "/     ^ self.
    "/ ].
    super update:something with:aParameter from:changedObject

    "Modified: / 23-06-2010 / 19:01:21 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CodeView2::GutterView methodsFor:'event handling'!

buttonPress: btn x: x y: y

    "Do not allow clicking on line numbers..."

    ((x < (self paddingLeft + widthAnnotations)) or:
        [x > (self width - self paddingRight - widthDiffInfo)])
        ifTrue:[
            (codeView buttonPress: btn x:x y:y in: self)
                ifFalse:[super buttonPress: btn x: x y: y]
        ] ifFalse:[
            super buttonPress: btn x: x y: y
        ]

    "Created: / 17-06-2011 / 13:02:54 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CodeView2::GutterView methodsFor:'initialization'!

initialize

    super initialize.
    widthAnnotations := 16.
    widthDiffInfo := 5.

    "Created: / 16-06-2011 / 13:47:10 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

setCodeView: aCodeView2

    codeView := aCodeView2.
    codeView addDependent: self.
    textView := aCodeView2 textView.
    textView addDependent: self.
    textViewScroller := aCodeView2 textViewScroller.
    self backgroundPaint: (textView backgroundPaint blendWith: (Color gray:80)).

    "Created: / 14-02-2010 / 15:19:40 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 17-06-2011 / 12:43:33 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CodeView2::GutterView methodsFor:'queries'!

displayedString: line
    "get text to display in gutter for specified list line number"

    ^(line asString).

    "Created: / 14-12-2009 / 13:37:47 / Jindra <a>"
!

firstLineShown
    "returns first line shown by associated text view"
    ^textView firstLineShown.

    "Created: / 14-12-2009 / 13:22:54 / Jindra <a>"
!

lastLineShown
    "returns last line shown by associated text view"
    ^textView lastLineShown.

    "Created: / 14-12-2009 / 13:23:07 / Jindra <a>"
!

lineColor:line
    "return special color for given line if required, nil otherwise"
    "used only if lineFont return nil"

    ^nil

    "Created: / 14-12-2009 / 15:01:31 / Jindra <a>"
!

lineDisplayable:line
    "true if this list line can be displayed"
    ^(textView listLineIsVisible:line)

    "Created: / 14-12-2009 / 13:38:23 / Jindra <a>"
!

lineFont:line
    "return special font for given line if required, nil otherwise"

    ^nil

    "Created: / 14-12-2009 / 14:40:17 / Jindra <a>"
!

yOfTextViewLine:line
    ^(textView yOfLine:line) + 1

    "Created: / 14-12-2009 / 13:35:07 / Jindra <a>"
! !

!CodeView2::GutterView methodsFor:'redrawing'!

redrawBackgroundX:x y:y width:w height:h
    "redraws gutter background"

    "background is filled with background color"
    self 
        fillRectangleX:x
        y:y
        width:w
        height:h
        color: self backgroundPaint.

    "separator line is drawn with foreground color"
    self 
        displayLineFromX:(self width - 2)
        y:y
        toX:(self width - 2)
        y:(y+h).

    "Created: / 14-12-2009 / 13:15:53 / Jindra <a>"
    "Modified: / 14-12-2009 / 15:09:54 / Jindra <a>"
!

redrawLine:line 

    ^self redrawLine:line cleared: false.

    "Modified: / 17-06-2011 / 14:12:31 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

redrawLine:line cleared: cleared
    "redraws specified line. Returns width of drawn object. Color of drawn objects should be taken from lineFont, lineColor"
    
    |lineString y0 textW requiredW oldFont newFont oldColor newColor|

    lineString := self displayedString:line.
    textW := (lineString widthOn:self).
    requiredW := textW + self padding.

    oldFont := self font.
    oldColor := self paint.
    newFont := self lineFont:line.
    newFont 
        ifNotNil:[ self font:newFont. ]
        ifNil:[
            newColor := self lineColor:line.
            newColor ifNotNil:[ self paint:newColor ].
        ].

    y0 := (self yOfTextViewLine:line) + ((self font) ascentOn:device).

    cleared ifFalse:[
        self clearRectangleX:0 y:y0 - font height width: self width - 2 height: font height + font descent.
    ].

    "Let the services to draw annotations and other stuff"
    codeView
        drawLine:line in: self 
        atX: self paddingLeft y:y0 width: widthAnnotations height: font height
        from:nil to:nil with:self paint and: self backgroundColor.

    self 
        displayString:lineString
        x:(self width - textW - self paddingRight - widthDiffInfo)
        y:y0.
    newFont 
        ifNotNil:[
            self font:oldFont.
            self paint:oldColor
        ]
        ifNil:[ newColor ifNotNil:[ self paint:oldColor ]. ].
    ^ requiredW.

    "Modified: / 14-12-2009 / 15:30:44 / Jindra <a>"
    "Created: / 17-06-2011 / 14:11:45 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

redrawX:x y:y width:w height:h 
    |first last requiredW currentW |

    self redrawBackgroundX:x y:y width:w height:h.

    first := self firstLineShown.
    last := self lastLineShown - 1 min: textView list size.

    currentW := requiredW := self width.
    first to:last do:
        [:line | 
        requiredW := requiredW max: (self redrawLine:line cleared: true)].

    (requiredW > self width) ifTrue:[
        self corner:(requiredW @ 1.0).
        textViewScroller origin:(requiredW @ 0.0) corner:(1.0 @ 1.0).
        self invalidate.
    ].

    "Created: / 03-09-2009 / 08:22:55 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 14-12-2009 / 14:13:14 / Jindra <a>"
    "Modified: / 17-06-2011 / 14:14:26 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CodeView2::TextView methodsFor:'accessing'!

changedDiffText
    ^ changedDiffText
!

changedDiffText:something
    changedDiffText := something.
!

changedLines
    ^ changedLines

    "Created: / 26-04-2010 / 20:30:32 / Jakub <zelenja7@fel.cvut.cz>"
    "Modified: / 26-04-2010 / 21:48:13 / Jakub <zelenja7@fel.cvut.cz>"
!

changedLines:something 
    changedLines := something.

    "Created: / 26-04-2010 / 20:30:19 / Jakub <zelenja7@fel.cvut.cz>"
    "Modified: / 02-05-2010 / 19:13:32 / Jakub <zelenja7@fel.cvut.cz>"
!

deletedLines
    ^  deletedLines

    "Modified: / 26-04-2010 / 21:48:23 / Jakub <zelenja7@fel.cvut.cz>"
!

deletedLines:something
deletedLines:=something.

    "Modified: / 26-04-2010 / 21:48:54 / Jakub <zelenja7@fel.cvut.cz>"
!

diffMode
    ^ diffMode
!

diffMode:something
    diffMode := something.
!

emptyLines
    ^ emptyLines
!

emptyLines:something
    emptyLines := something.
!

insertedLines
    ^  insertedLines

    "Modified: / 26-04-2010 / 21:48:27 / Jakub <zelenja7@fel.cvut.cz>"
!

insertedLines:something
insertedLines:=something.

    "Modified: / 26-04-2010 / 21:48:59 / Jakub <zelenja7@fel.cvut.cz>"
!

originDiffText
    ^ originDiffText
!

originDiffText:something
    originDiffText := something.
! !

!CodeView2::TextView methodsFor:'accessing - colors'!

colorChanged
    ^ Color redByte:240 greenByte: 192 blueByte: 192

    "Modified: / 24-06-2010 / 14:05:03 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

colorDeleted

    ^ self colorInserted.
    
    "/^ Color pink

    "Modified: / 24-06-2010 / 14:16:42 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

colorInserted
    ^ Color redByte: 239 greenByte: 225 blueByte: 152

    "Modified: / 24-06-2010 / 14:13:14 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CodeView2::TextView methodsFor:'actions'!

cancel

    self halt.

    "Created: / 08-02-2010 / 09:29:43 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CodeView2::TextView methodsFor:'drawing'!

drawFromVisibleLine:startVisLineNr to:endVisLineNr with:fg and:bg 

    super 
        drawFromVisibleLine:startVisLineNr
        to:endVisLineNr
        with:fg
        and:bg.
    self redrawLines.

    "Created: / 05-04-2010 / 12:08:38 / Jakub <zelenja7@fel.cvut.cz>"
    "Modified: / 02-05-2010 / 18:46:04 / Jakub <zelenja7@fel.cvut.cz>"
!

drawLine:line fromX:x inVisible:visLineNr with:fg and:bg 

    super 
        drawLine:line
        fromX:x
        inVisible:visLineNr
        with:fg
        and:bg.
    self redrawLines.

    "Created: / 05-04-2010 / 12:07:07 / Jakub <zelenja7@fel.cvut.cz>"
    "Modified: / 02-05-2010 / 18:46:00 / Jakub <zelenja7@fel.cvut.cz>"
!

drawLine:lineStringArg inVisible:visLineNr col:col with:fg and:bg 

    super 
        drawLine:lineStringArg
        inVisible:visLineNr
        col:col
        with:fg
        and:bg.
    self redrawLines.

    "Created: / 05-04-2010 / 11:49:42 / Jakub <zelenja7@fel.cvut.cz>"
    "Modified: / 02-05-2010 / 18:45:56 / Jakub <zelenja7@fel.cvut.cz>"
!

drawLine:lineStringArg inVisible:visLineNr from:startCol to:endColOrNil with:fg and:bg 

    super 
        drawLine:lineStringArg
        inVisible:visLineNr
        from:startCol
        to:endColOrNil
        with:fg
        and:bg.
    self redrawLines.

    "Created: / 05-04-2010 / 11:54:54 / Jakub <zelenja7@fel.cvut.cz>"
    "Modified: / 02-05-2010 / 18:45:52 / Jakub <zelenja7@fel.cvut.cz>"
!

drawLine:lineString inVisible:visLineNr from:startCol with:fg and:bg 

    super 
        drawLine:lineString
        inVisible:visLineNr
        from:startCol
        with:fg
        and:bg.
    self redrawLines.

    "Created: / 05-04-2010 / 11:54:26 / Jakub <zelenja7@fel.cvut.cz>"
    "Modified: / 02-05-2010 / 18:45:48 / Jakub <zelenja7@fel.cvut.cz>"
!

drawVisibleLine:visLineNr with:fg and:bg 

    super 
        drawVisibleLine:visLineNr
        with:fg
        and:bg.
    self redrawLines.

    "Created: / 05-04-2010 / 11:49:42 / Jakub <zelenja7@fel.cvut.cz>"
    "Modified: / 02-05-2010 / 18:45:44 / Jakub <zelenja7@fel.cvut.cz>"
!

redraw
    "/ thisContext fullPrintAll.   
    super redraw.

    "Created: / 30-06-2011 / 11:04:32 / cg"
!

redrawLines
    |i pom|

    diffMode ifFalse:[^self].

    pom := self hasSelection.
    (pom) ifTrue:[ ^ self. ].
    i := 1.
    [
        i <= (deletedLines size)
    ] whileTrue:[
        ((deletedLines at:i) > 0) ifTrue:[
            super 
                drawVisibleLine:(deletedLines at:i)
                with:fgColor
                and:self colorDeleted.
        ].
        i := i + 1.
    ].
    i := 1.
    [
        i <= (insertedLines size)
    ] whileTrue:[
        ((insertedLines at:i) > 0) ifTrue:[
            super 
                drawVisibleLine:(insertedLines at:i)
                with:fgColor
                and:self colorInserted.
        ].
        i := i + 1.
    ].
    i := 1.
    [
        i <= (changedLines size)
    ] whileTrue:[
        ((changedLines at:i) > 0) ifTrue:[
            super 
                drawVisibleLine:(changedLines at:i)
                with:fgColor
                and:self colorChanged.
        ].
        i := i + 1.
    ].

    "Created: / 26-04-2010 / 21:04:31 / Jakub <zelenja7@fel.cvut.cz>"
    "Modified: / 22-06-2010 / 23:28:30 / Jakub <zelenja7@fel.cvut.cz>"
    "Modified: / 08-04-2011 / 20:52:18 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CodeView2::TextView methodsFor:'editing'!

contentsChanged
    super contentsChanged.
    "
    codeView diffMode ifTrue:[
        changedDiffText ifTrue:[
            codeView recomputeDiff:self.
        ] ifFalse:[
            changedDiffText := true.
        ].  
    ]
    "

    "Created: / 22-06-2010 / 23:13:24 / Jakub <zelenja7@fel.cvut.cz>"
    "Modified: / 01-08-2010 / 20:33:07 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

getNewOriginText
    |i size pole pom text helperText|

    i := 1.
    pole := list.
    size := list size.
    text:=''.
    emptyLines ifNil:[emptyLines := #()].
    [ i <= size ] whileTrue:[
        pom := emptyLines indexOf:i.
        (pom = 0) ifFalse:[
            helperText := pole at:i.
            (helperText = '') ifFalse:[
                (helperText isNil)ifTrue:[helperText:=''].
                helperText:=helperText,Character cr.
                text := text asString , helperText asString.
            ].
        ] ifTrue:[
            helperText := pole at:i.
            (helperText isNil)ifTrue:[helperText:=''].
            helperText:=helperText,Character cr.
            text := text asString , helperText asString.
        ].
    i:=i+1.
    ].
^text

    "Created: / 22-06-2010 / 22:33:27 / Jakub <zelenja7@fel.cvut.cz>"
    "Modified: / 24-06-2010 / 14:27:03 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CodeView2::TextView methodsFor:'editing-basic'!

basicDeleteFromLine:startLineNr toLine:endLineNr

    self notifyLinesDeletedFrom: startLineNr to: endLineNr.  

    super basicDeleteFromLine:startLineNr toLine:endLineNr

    "Created: / 28-06-2011 / 09:09:25 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

basicDeleteLineWithoutRedraw:lineNr

    self notifyLinesDeletedFrom: lineNr to: lineNr. 

    ^super basicDeleteLineWithoutRedraw:lineNr

    "Created: / 28-06-2011 / 09:10:04 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

basicMergeLine:lineNr removeBlanks:removeBlanks

    self notifyLinesDeletedFrom: lineNr + 1 to: lineNr + 1.

    super basicMergeLine:lineNr removeBlanks:removeBlanks

    "Created: / 28-06-2011 / 09:13:36 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

basicSplitLine:lineNr before:colNr

    self notifyLinesInsertedFrom: lineNr +1 to: lineNr + 1. 

    ^super basicSplitLine:lineNr before:colNr

    "Created: / 28-06-2011 / 09:14:50 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CodeView2::TextView methodsFor:'event handling'!

buttonMotion:button x:x y:y

    (codeView buttonMotion:button x:x y:y in: self)
        ifFalse:[super buttonMotion:button x:x y:y].

    "Created: / 14-02-2010 / 16:23:09 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 06-03-2010 / 20:10:10 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

buttonPress: button x: x y: y
    | ctrlDown  |

    (codeView buttonPress:button x:x y:y in: self)
        ifFalse:[super buttonPress:button x:x y:y].
    "
    ((ctrlDown := self sensor ctrlDown) and: [ codeView syntaxElementSelection notNil]) 
        ifTrue: [codeView buttonPressInTextView: button x:x y:y ctrlDown: ctrlDown].
    super 
        buttonPress: button
        x: x
        y: y
    "

    "Created: / 14-02-2010 / 18:12:32 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 06-03-2010 / 20:37:41 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

exposeX:x y:y width:w height:h 
    super 
        exposeX:x
        y:y
        width:w
        height:h.
    self redrawLines.

    "Created: / 05-04-2010 / 10:07:50 / Jakub <zelenja7@fel.cvut.cz>"
    "Modified: / 02-05-2010 / 18:41:07 / Jakub <zelenja7@fel.cvut.cz>"
!

keyPress:key x:x y:y
    (codeView keyPress:key x:x y:y in: self)
        ifFalse:[super keyPress:key x:x y:y].

    "Modified: / 06-03-2010 / 20:34:51 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 05-04-2010 / 09:55:52 / Jakub <zelenja7@fel.cvut.cz>"
!

keyRelease: key x: x y: y

    (codeView keyRelease:key x:x y:y in: self)
        ifFalse:[super keyRelease:key x:x y:y].
    "
    (key = #Control_L) ifTrue:
        [ codeView highlightClear. self redraw ].

    ^ super 
        keyRelease: key
        x: x
        y: y
    "

    "Created: / 14-02-2010 / 16:38:46 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 06-03-2010 / 21:04:55 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CodeView2::TextView methodsFor:'initialization'!

initialize

    super initialize.

    changedDiffText := true.
    diffMode := false.

    "Created: / 23-06-2010 / 17:28:52 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 08-04-2011 / 20:50:37 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

setCodeView: aCodeView2

    codeView := aCodeView2.
    codeView addDependent: self.
    gutterView := aCodeView2 gutterView.

    "Created: / 14-02-2010 / 15:22:47 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 17-06-2011 / 12:43:53 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

setGutterView: aGutterView

    self assert: gutterView isNil message:'Attempting to set gutterView twice'.
    gutterView := aGutterView.
    gutterView setTextView: self.

    "Created: / 02-09-2009 / 21:57:53 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CodeView2::TextView methodsFor:'menu & menu actions'!

editMenu

    ^codeView editMenu

    "Created: / 14-02-2010 / 15:49:03 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CodeView2::TextView methodsFor:'notification'!

notifyLinesDeletedFrom: startLine to: endLine

    "Created: / 28-06-2011 / 09:12:04 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

notifyLinesInsertedFrom: startLine to: endLine

    "Created: / 28-06-2011 / 09:12:14 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CodeView2::TextView methodsFor:'private'!

superEditMenu

    ^super editMenu

    "Created: / 14-02-2010 / 15:48:00 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CodeView2::TextView methodsFor:'scrolling'!

basicScrollDown:nLines 
    |i|

    (lastFirstLine isNil) ifTrue:[
        lastFirstLine := firstLineShown.
    ].
    super scrollDown:nLines.
    (lastFirstLine = firstLineShown) ifFalse:[
        i := 1.
        [
            i <= changedLines size
        ] whileTrue:[
            super 
                drawVisibleLine:(changedLines at:i)
                with:fgColor
                and:Color white.
            changedLines at:i put:(changedLines at:i) - nLines.
            i := i + 1.
        ].
        i := 1.
        [
            i <= insertedLines size
        ] whileTrue:[
            super 
                drawVisibleLine:(insertedLines at:i)
                with:fgColor
                and:Color white.
            insertedLines at:i put:(insertedLines at:i) - nLines.
            i := i + 1.
        ].
        i := 1.
        [
            i <= deletedLines size
        ] whileTrue:[
            super 
                drawVisibleLine:(deletedLines at:i)
                with:fgColor
                and:Color white.
            deletedLines at:i put:(deletedLines at:i) - nLines.
            i := i + 1.
        ].
        lastFirstLine := firstLineShown.
        self redrawLines.
    ].

    "Created: / 06-04-2010 / 14:03:28 / Jakub <zelenja7@fel.cvut.cz>"
    "Modified: / 02-05-2010 / 19:29:23 / Jakub <zelenja7@fel.cvut.cz>"
!

basicScrollUp:nLines 
    |i|

    (scrolled isNil) ifTrue:[
        scrolled := false.
    ].
    (lastFirstLine isNil) ifTrue:[
        lastFirstLine := firstLineShown.
    ].
    super scrollUp:nLines.
    (lastFirstLine = firstLineShown) ifFalse:[
        i := 1.
        [
            i <= insertedLines size
        ] whileTrue:[
            super 
                drawVisibleLine:(insertedLines at:i)
                with:fgColor
                and:Color white.
            insertedLines at:i put:(insertedLines at:i) + nLines.
            i := i + 1.
        ].
        i := 1.
        [
            i <= deletedLines size
        ] whileTrue:[
            super 
                drawVisibleLine:(deletedLines at:i)
                with:fgColor
                and:Color white.
            deletedLines at:i put:(deletedLines at:i) + nLines.
            i := i + 1.
        ].
        i := 1.
        [
            i <= changedLines size
        ] whileTrue:[
            super 
                drawVisibleLine:(changedLines at:i)
                with:fgColor
                and:Color white.
            changedLines at:i put:(changedLines at:i) + nLines.
            i := i + 1.
        ].
        lastFirstLine := firstLineShown.
        self redrawLines.
    ].

    "Created: / 06-04-2010 / 14:03:46 / Jakub <zelenja7@fel.cvut.cz>"
    "Modified: / 02-05-2010 / 19:19:27 / Jakub <zelenja7@fel.cvut.cz>"
!

originChanged:delta

    super originChanged:delta.

    gutterView invalidate.

    "Created: / 07-12-2009 / 21:50:49 / Jindra <a>"
!

scrollDown:nLines

    codeView scrollDown: nLines in: self.
    self basicScrollDown: nLines.

    "Modified: / 06-04-2010 / 14:04:28 / Jakub <zelenja7@fel.cvut.cz>"
!

scrollUp:nLines

    codeView scrollUp: nLines in: self.
    self basicScrollUp: nLines.

    "Modified: / 06-04-2010 / 14:05:40 / Jakub <zelenja7@fel.cvut.cz>"
! !

!CodeView2 class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/libtool/Tools__CodeView2.st,v 1.1 2011-07-01 13:21:21 cg Exp $'
!

version_SVN
    ^ 'Id: Tools__CodeView2.st 7797 2011-06-28 07:45:06Z vranyj1 '
! !

CodeView2 initialize!
